diff -ru --new-file util-linux-2.11y/mount/lomount.c util-linux-AES/mount/lomount.c
--- util-linux-2.11y/mount/lomount.c	Fri Nov  1 02:58:51 2002
+++ util-linux-AES/mount/lomount.c	Wed Feb 12 17:06:01 2003
@@ -386,51 +1098,232 @@
 	fprintf (stderr, "\n");
 }
 
+void
+show_all_loops(void)
+{
+ 	char dev[20];
+ 	char *lfmt[] = { "/dev/loop%d", "/dev/loop/%d" };
+ 	int i, j, fd, x;
+ 	struct stat statbuf;
+ 	struct loop_info loopinfo;
+
+	for(i = 0; i < 256; i++) {
+	        for(j = (sizeof(lfmt) / sizeof(lfmt[0])) - 1; j >= 0; j--) {
+	                sprintf(dev, lfmt[j], i);
+	                if(stat(dev, &statbuf) == 0 && S_ISBLK(statbuf.st_mode)) {
+	                        fd = open(dev, O_RDONLY);
+	                        if(fd >= 0) {
+	                                x = ioctl(fd, LOOP_GET_STATUS, &loopinfo);
+	                                close(fd);
+ 	                                if(x == 0) {
+		                                show_loop(dev);
+   			                        j = 0;
+                                        }
+                                }
+			}
+	        }
+	}
+}
+
+int
+read_options_from_fstab(char *loopToFind, char **partitionPtr, char **offsetPtr, char **encryptionPtr,
+			char **passSeedString, char **passHashFuncName, 
+			char **loInitValue, char **gpgKeyFile, char **gpgHomeDir,
+			char **passIterThousands)
+{
+ 	FILE *f;
+ 	struct mntent *m;
+	int y, foundMatch = 0;
+        char *opt;
+        struct options {
+                char *name;	/* name of /etc/fstab option */
+		        char **dest;    /* destination where it is written to */
+	        char *line;     /* temp */
+	};
+	struct options tbl[] = {
+	        { "device/file name ",  partitionPtr }, /* must be index 0 */
+	 	{ "loop=",              &loopToFind },  /* must be index 1 */
+ 		{ "offset=",		offsetPtr },
+		{ "encryption=",	encryptionPtr },
+   		{ "pseed=",     	passSeedString },
+                { "phash=",             passHashFuncName },
+ 		{ "loinit=",		loInitValue },
+   	        { "gpgkey=",		gpgKeyFile }, 
+                { "gpghome=",   	gpgHomeDir },
+                { "itercountk=",	passIterThousands },
+        };
+        struct options *p;
+
+	if (!(f = setmntent("/etc/fstab", "r"))) {
+	        fprintf(stderr, _("Error: unable to open /etc/fstab for reading\n"));
+	  	return 0;
+        }
+        while ((m = getmntent(f)) != NULL) {
+		tbl[0].line = xstrdup(m->mnt_fsname);
+		p = &tbl[1];
+		do {
+                    	p->line = NULL;
+		} while (++p < &tbl[sizeof(tbl) / sizeof(struct options)]);
+		for (opt = strtok(xstrdup(m->mnt_opts), ","); opt != NULL; opt = strtok(NULL, ",")) {
+			p = &tbl[1];
+			do {
+                            	y = strlen(p->name);
+                                if (!strncmp(opt, p->name, y))
+                                        p->line = opt + y;
+			} while (++p < &tbl[sizeof(tbl) / sizeof(struct options)]);
+		}
+                if (tbl[1].line && !strcmp(loopToFind, tbl[1].line)) {
+			if (++foundMatch > 1) {
+                                fprintf(stderr, _("Error: multiple loop=%s options found in /etc/fstab\n"), loopToFind);
+                                endmntent(f);
+                                return 0;
+			}
+                        p = &tbl[0];
+			do {
+                            	if (!*p->dest && p->line) {
+                                        *p->dest = p->line;
+                                        if (verbose)
+                                                printf(_("using %s%s from /etc/fstab\n"), p->name, p->line);
+                                }
+                        } while (++p < &tbl[sizeof(tbl) / sizeof(struct options)]);
+		}
+	}
+	endmntent(f);
+	if (foundMatch == 0) {
+	        fprintf(stderr, _("Error: loop=%s option not found in /etc/fstab\n"), loopToFind);
+	}
+	return foundMatch;
+}
+
+
 int
 main(int argc, char **argv) {
-	char *offset, *encryption;
-	int delete,off,c;
+	char *offset = 0, *encryption = 0, *passfd = 0, *keysize = 0, *phash_name = 0, *blockmode = 0;
+	int delete = 0, off = 0, c = 0,option_a=0,option_F=0;
+	char *passIterThousands = NULL;
+	char *gpgHomeDir = NULL;
+	char *gpgKeyFile = NULL;
+	char *passSeedString = NULL;
+	char *loInitValue = NULL;
+	char *partitionName = NULL;
+	int pfd = -1;
 	int res = 0;
 	int ro = 0;
+	int keysz = 0;
+	int passAskTwice = 0;
 
 	setlocale(LC_ALL, "");
 	bindtextdomain(PACKAGE, LOCALEDIR);
 	textdomain(PACKAGE);
 
-	delete = off = 0;
-	offset = encryption = NULL;
 	progname = argv[0];
-	while ((c = getopt(argc,argv,"de:o:v")) != -1) {
+	while ((c = getopt_long(argc,argv,"aC:b:de:FG:H:I:K:h:k:o:p:P:S:Tv",
+				longopts, NULL)) != -1) {
 		switch (c) {
+   	        case 'a':               /* show status of all loops */
+			option_a = 1;
+			break;
+	        case 'C':
+			passIterThousands = optarg;
+			break;
+		case 'b':
+			blockmode = optarg;
+			break;
 		case 'd':
 			delete = 1;
 			break;
 		case 'e':
 			encryption = optarg;
 			break;
+		case 'F':     		/* read loop related options from /etc/fstab */
+			option_F = 1;
+			break;
+        	case 'G':     		/* GnuPG home dir */
+                        gpgHomeDir = optarg;
+   	                break;
+	        case 'I':     		/* lo_init[0] value (in string form)  */
+		        loInitValue = optarg;
+                        break;
+                case 'K':     		/* GnuPG key file name */
+                        gpgKeyFile = optarg;
+                        break;
+		case 'k':
+		        keysize = optarg;
+			break;
 		case 'o':
 			offset = optarg;
 			break;
+		case 'p':
+		        passfd = optarg;
+			break;
+		case 'P':
+		        phash_name = optarg;
+			break;
+	        case 'S':     		/* optional seed for passphrase */
+                        passSeedString = optarg;
+	                break;
+        	case 'T':     		/* ask passphrase _twice_ */
+                        passAskTwice = 1;
+   	                break;
 		case 'v':
-			verbose = 1;
+			verbose++;
 			break;
 		default:
 			usage();
 		}
 	}
 	if (argc == 1) usage();
-	if ((delete && (argc != optind+1 || encryption || offset)) ||
+	if (option_a) {
+		if (delete || (argc != optind)) usage();
+		show_all_loops();
+		exit(0);
+	}
+	printf("%d %d\n",optind,argc);
+	if ((delete && (argc != optind+1 || encryption || offset || passfd || option_a || option_F)) ||
 	    (!delete && (argc < optind+1 || argc > optind+2)))
 		usage();
+        if (argc > optind+1)
+                partitionName = argv[optind+1];
+        if (option_F && (read_options_from_fstab(argv[optind], &partitionName, 
+        					 &offset, &encryption, 
+        					 &passSeedString, &phash_name, 
+        					 &loInitValue, &gpgHomeDir, 
+        					 &gpgKeyFile, &passIterThousands) != 1))
+		exit(1);
+                        
 	if (argc == optind+1) {
 		if (delete)
 			res = del_loop(argv[optind]);
 		else
-			res = show_loop(argv[optind]);
+			if(!option_F)
+				res = show_loop(argv[optind]);
 	} else {
 		if (offset && sscanf(offset,"%d",&off) != 1)
 			usage();
-		res = set_loop(argv[optind],argv[optind+1],off,encryption,&ro);
+		if (passfd && sscanf(passfd,"%d",&pfd) != 1)
+		        usage();
+		if (keysize)
+		{
+			if(strcmp(keysize,"auto") == 0)
+				keysz = -1;
+			else 
+			if (sscanf(keysize,"%d",&keysz) != 1)
+			        usage();
+		}
+		if (!blockmode || strlen(blockmode) != 3) {
+//			fprintf(stderr, "no block mode given or invalid blockmode, defaulting to cbc.\n");
+			blockmode = "cbc";
+		}
+		if (!strcmp(blockmode, "ctr")) {
+			fprintf(stderr, "counter mode is not recommend for file system encryption as it may be insecure. consider using rtc mode or another blockmode.\n");
+			return -1;
+		}
+			
+		res = set_loop(argv[optind], partitionName, off,
+			       encryption, pfd, keysz, &ro,
+			       phash_name,
+			       blockmode,passIterThousands,gpgHomeDir,gpgKeyFile,
+			       passAskTwice, loInitValue, passSeedString);
 	}
 	return res;
 }
@@ -446,3 +1339,32 @@
 }
 #endif
 #endif
+
+
+
+static int 
+name_to_id(const char *name) 
+{
+	int i;
+
+	if (name) {
+		for (i = 0; crypt_type_tbl[i].id != -1; i++)
+			if (!strcasecmp (name, crypt_type_tbl[i].name))
+				return crypt_type_tbl[i].id;
+	} else
+		return LO_CRYPT_NONE;
+	return LO_CRYPT_CRYPTOAPI;
+}
+
+#ifdef MAIN
+static char *
+id_to_name(int id) {
+	int i;
+
+	for (i = 0; crypt_type_tbl[i].id != -1; i++)
+		if (id == crypt_type_tbl[i].id)
+			return crypt_type_tbl[i].name;
+	return "undefined";
+}
+#endif
+
diff -ru --new-file util-linux-2.11y/mount/lomount.h util-linux-AES/mount/lomount.h
--- util-linux-2.11y/mount/lomount.h	Fri Dec  8 19:08:02 2000
+++ util-linux-AES/mount/lomount.h	Sun Feb  9 21:19:32 2003
@@ -1,5 +1,9 @@
 extern int verbose;
-extern int set_loop (const char *, const char *, int, const char *, int *);
+extern int set_loop (const char *device, const char *file, int offset,
+          const char *encryption, int pfd, int keysz, int *loopro, 
+          const char *phash_name, const char *blockmode, char *passIterThousands, 
+          char *gpgHomeDir, char *gpgKeyFile, int passAskTwice, char *loInitValue,
+          char *passSeedString);
 extern int del_loop (const char *);
 extern int is_loop_device (const char *);
 extern char * find_unused_loop_device (void);
diff -ru --new-file util-linux-2.11y/mount/loop-aes-conversion util-linux-AES/mount/loop-aes-conversion
--- util-linux-2.11y/mount/loop-aes-conversion	Thu Jan  1 01:00:00 1970
+++ util-linux-AES/mount/loop-aes-conversion	Mon Feb 10 01:37:23 2003
@@ -0,0 +1,8 @@
+Loop AES styled losetup conversion "guide":
+
+loop-AES			util-linux-2.12
+--------------------------------------------------------------------
+losetup -e aes128		losetup -e rijndael -k 128 -P sha256
+losetup -e aes192		losetup -e rijndael -k 192 -P sha384
+losetup -e aes256		losetup -e rijndael -k 256 -P sha512
+losetup -e aes			losetup -e rijndael -k auto -P hexconv
diff -ru --new-file util-linux-2.11y/mount/loumount.c util-linux-AES/mount/loumount.c
--- util-linux-2.11y/mount/loumount.c	Thu Jan  1 01:00:00 1970
+++ util-linux-AES/mount/loumount.c	Thu Feb  6 23:27:00 2003
@@ -0,0 +1,78 @@
+/*
+ *  loumount.c
+ *
+ *  This code was extracted to separate file from lomount.c so that umount
+ *  program doesn't have to link with all loop related setup code
+ */
+
+#define PROC_DEVICES	"/proc/devices"
+
+#include <stdio.h>
+#include <string.h>
+#include <ctype.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <pwd.h>
+#include <sys/types.h>
+#include <sys/ioctl.h>
+#include <sys/stat.h>
+#include <sys/mman.h>
+#include <sys/sysmacros.h>
+#include <sys/wait.h>
+#include <fcntl.h>
+#include <mntent.h>
+#include <locale.h>
+
+#include "loop.h"
+#include "lomount.h"
+#include "xstrncpy.h"
+#include "nls.h"
+
+int
+is_loop_device (const char *device) {
+	struct stat statbuf;
+	int loopmajor;
+#if 1
+	loopmajor = 7;
+#else
+	FILE *procdev;
+	char line[100], *cp;
+
+	loopmajor = 0;
+	if ((procdev = fopen(PROC_DEVICES, "r")) != NULL) {
+		while (fgets (line, sizeof(line), procdev)) {
+			if ((cp = strstr (line, " loop\n")) != NULL) {
+				*cp='\0';
+				loopmajor=atoi(line);
+				break;
+			}
+		}
+		fclose(procdev);
+	}
+#endif
+	return (loopmajor && stat(device, &statbuf) == 0 &&
+		S_ISBLK(statbuf.st_mode) &&
+		major(statbuf.st_rdev) == loopmajor);
+}
+
+int 
+del_loop (const char *device) {
+	int fd;
+
+	if ((fd = open (device, O_RDONLY)) < 0) {
+		int errsv = errno;
+		fprintf(stderr, _("loop: can't delete device %s: %s\n"),
+			device, strerror (errsv));
+		return 1;
+	}
+	if (ioctl (fd, LOOP_CLR_FD, 0) < 0) {
+		perror ("ioctl: LOOP_CLR_FD");
+		return 1;
+	}
+	close (fd);
+	if (verbose > 1)
+		printf(_("del_loop(%s): success\n"), device);
+	return 0;
+}
diff -ru --new-file util-linux-2.11y/mount/mount.c util-linux-AES/mount/mount.c
--- util-linux-2.11y/mount/mount.c	Fri Nov  1 02:00:50 2002
+++ util-linux-AES/mount/mount.c	Wed Feb 12 17:05:12 2003
@@ -110,6 +110,9 @@
 /* True if ruid != euid.  */
 static int suid = 0;
 
+/* Contains the fd no. to read the passphrase from, if any */
+static int pfd = -1;
+
 /* Map from -o and fstab option strings to the flag argument to mount(2).  */
 struct opt_map {
   const char *opt;		/* option name */
@@ -189,7 +192,9 @@
 };
 
 static char *opt_loopdev, *opt_vfstype, *opt_offset, *opt_encryption,
-  *opt_speed;
+  *opt_keybits, *opt_speed, *opt_phash, *opt_blockmode;
+static char *passSeedString, *loInitValue;
+static char *gpgKeyFile, *gpgHomeDir, *passIterThousands;
 
 static struct string_opt_map {
   char *tag;
@@ -200,7 +205,15 @@
   { "vfs=",	1, &opt_vfstype },
   { "offset=",	0, &opt_offset },
   { "encryption=", 0, &opt_encryption },
+  { "keybits=", 0, &opt_keybits },
+  { "phash=", 0, &opt_phash },
   { "speed=", 0, &opt_speed },
+  { "blockmode=", 0, &opt_blockmode },
+  { "pseed=",   1, &passSeedString },
+  { "loinit=",  0, &loInitValue },
+  { "gpgkey=",  0, &gpgKeyFile }, 
+  { "gpghome=", 0, &gpgHomeDir }, 
+  { "itercountk=", 1, &passIterThousands },
   { NULL, 0, NULL }
 };
 
@@ -550,7 +563,7 @@
 static int
 loop_check(char **spec, char **type, int *flags,
 	   int *loop, char **loopdev, char **loopfile) {
-  int looptype, offset;
+  int looptype, offset, keybits;
 
   /*
    * In the case of a loop mount, either type is of the form lo@/dev/loop5
@@ -593,7 +606,11 @@
       if (verbose)
 	printf(_("mount: going to use the loop device %s\n"), *loopdev);
       offset = opt_offset ? strtoul(opt_offset, NULL, 0) : 0;
-      if (set_loop (*loopdev, *loopfile, offset, opt_encryption, &loopro)) {
+      keybits = opt_keybits ? strtoul(opt_keybits, NULL, 0) : 0;
+      if (set_loop (*loopdev, *loopfile, offset, opt_encryption, pfd, 
+		    keybits, &loopro,
+		    opt_phash, opt_blockmode, passIterThousands, gpgHomeDir,
+		    gpgKeyFile, 0, loInitValue, passSeedString)) {
 	if (verbose)
 	  printf(_("mount: failed setting up loop device\n"));
 	return EX_FAIL;
@@ -1356,6 +1373,7 @@
 	{ "rw", 0, 0, 'w' },
 	{ "options", 1, 0, 'o' },
 	{ "test-opts", 1, 0, 'O' },
+	{ "pass-fd", 1, 0, 'p' },
 	{ "types", 1, 0, 't' },
 	{ "bind", 0, 0, 128 },
 	{ "replace", 0, 0, 129 },
@@ -1392,7 +1410,7 @@
 	  "       mount --move olddir newdir\n"
 	  "A device can be given by name, say /dev/hda1 or /dev/cdrom,\n"
 	  "or by label, using  -L label  or by uuid, using  -U uuid .\n"
-	  "Other options: [-nfFrsvw] [-o options].\n"
+	  "Other options: [-nfFrsvw] [-o options] [-p num].\n"
 	  "For many more details, say  man 8 mount .\n"
 	));
 /*
@@ -1408,6 +1426,7 @@
 	int c, result = 0, specseen;
 	char *options = NULL, *test_opts = NULL, *spec, *node;
 	char *volumelabel = NULL;
+	char *passfd = NULL;
 	char *uuid = NULL;
 	char *types = NULL;
 	struct mntentchn *mc;
@@ -1431,7 +1450,7 @@
 	initproctitle(argc, argv);
 #endif
 
-	while ((c = getopt_long (argc, argv, "afFhlL:no:O:rsU:vVwt:",
+	while ((c = getopt_long (argc, argv, "afFhlL:no:O:p:rsU:vVwt:",
 				 longopts, NULL)) != -1) {
 		switch (c) {
 		case 'a':	       /* mount everything in fstab */
@@ -1467,6 +1486,9 @@
 			else
 				test_opts = xstrdup(optarg);
 			break;
+		case 'p':               /* read passphrase from given fd */
+		        passfd = optarg;
+			break;
 		case 'r':		/* mount readonly */
 			readonly = 1;
 			readwrite = 0;
@@ -1575,6 +1597,9 @@
 			printf(_("mount: mounting %s\n"), spec);
 	} else
 		spec = NULL;		/* just for gcc */
+
+	if (passfd && sscanf(passfd,"%d",&pfd) != 1)
+	        die (EX_USAGE, _("mount: argument to --pass-fd or -p must be a number"));
 
 	switch (argc+specseen) {
 	case 0:
